<!--
/**
* --------------------------------------------------------------------------
* @Copyright : SAS Spopit
*
* @Author : Alexandre Caillot
*
* @File : PU.vue
* @Created_at : 14/10/2019
* @Update_at : 15/10/2019
* --------------------------------------------------------------------------
*/
-->

<style scoped>
    .container {
        display: flex;
        flex: 1 1 auto;
        flex-direction: column;
    }

    .pu {
        display: flex;
        flex: 1 1 auto;

        height: 0;

        overflow: hidden;
    }
</style>

<script>
    import Visual3DEntity from "../entity/Visual3D/Visual3DEntity";

    export default {
        name: 'PU',

        data: () => {
            return {
                visual3D: null,

                options: {
                    visual3D: {
                        camera: {
                            position: {
                                x: 0,
                                y: 0,
                                z: 100
                            }
                        },
                        crosshair: {
                            enable: true,
                            material: {
                                map: "commons/images/textures/crosshair/crosshair.png",
                                transparency: true
                            },
                            size: {
                                "x": 10,
                                "y": 10,
                                "z": 10
                            },
                            position: {
                                "x": 0,
                                "y": 0,
                                "z": -250
                            }
                        },
                        lights: [
                            {
                                type: "ambient",
                                color: "#FFFFFF",
                                intensity: 2,
                            },
                            {
                                type: 'directional',
                                attached: 'camera',
                                position: {
                                    x: 500,
                                    y: 500,
                                    z: -100,
                                },
                                color: '#FFFFFF',
                                intensity: 1.5
                            }
                        ],
                        renderer: {type: 'webgl'},
                        // scene: {transparency: true}
                        scene: {color: '#2a2a2a'},
                        callbacks: {
                            clickObject: null
                        },
                        pu: {
                            selectedObject: {
                                animate: 'wave'
                            }
                        }
                    }
                }
            }
        },

        // On Mounted Event (Component)
        mounted() {
            this.options.visual3D.callbacks.clickObject = this.clickObject.bind(this);

            this.visual3D = new Visual3DEntity(this.$refs.PU, this.options.visual3D);
            this.visual3D.boot();
            this.visual3D.enableShortcut();
            // this.visual3D.enableMultiSelection();
            // this.visual3D.disableAnimation();
            // this.visual3D.disableControl();

            this.generateObject();
            // this.generateObjects();
            this.generateLines();
        },

        destroyed() {
            this.visual3D.dispose();
        },

        methods: {
            /**
             * Generate One Object.
             */
            generateObject() {
                /** @var visual3D Visual3DEntity */
                this.visual3D.buildObject({
                    id: 'Object_1',
                    name: 'First Object',
                    status: null,

                    clickable: true,

                    container: 'sphere',
                    geometry: 'model',
                    model: '/commons/models/man/man.fbx',
                    material: {
                        side: 'front',
                        map: '/commons/models/man/textures/man_redShirt.jpg',
                        roughness: 0.8,
                        metalness: 0,
                        transparency: true
                    },

                    position: {x: -25, y: 0, z: 0},
                    rotation: {x: 0, y: 0, z: 0},
                    size: {x: 10, y: 10, z: 10},

                    subObjects: [
                        {
                            id: '~SO~0',
                            name: 'First Object',
                            status: null,

                            parentId: 'Object_1',

                            geometry: 'text',
                            material: {
                                side: 'double',
                                color: "#FFF"
                            },
                            position: {x: 0, y: '-17', z: 0},
                            rotation: {x: 0, y: 0, z: 0},
                            size: 4
                        }
                    ]
                });

                /** @var visual3D Visual3DEntity */
                this.visual3D.buildObject({
                    id: 'Object_2',
                    name: 'Second Object',
                    status: null,

                    clickable: true,

                    container: 'sphere',
                    geometry: 'model',
                    model: '/commons/models/man/man.fbx',
                    material: {
                        map: '/commons/models/man/textures/man_redShirt.jpg',
                        roughness: 0.8,
                        metalness: 0,
                        transparency: true
                    },

                    position: {x: 25, y: 0, z: 0},
                    rotation: {x: 0, y: 0, z: 0},
                    size: {x: 10, y: 10, z: 10},

                    subObjects: [
                        {
                            id: '~SO~0',
                            name: 'Second Object',
                            status: null,

                            parentId: 'Object_2',

                            geometry: 'text',
                            material: {
                                side: 'double',
                                color: "#FFF"
                            },
                            position: {x: 0, y: '-17', z: 0},
                            rotation: {x: 0, y: 0, z: 0},
                            size: 4
                        }
                    ]
                });
            },

            /**
             * Generate Some Objects.
             */
            generateObjects() {
                for (let i = 0; i < 30; i++) {
                    /** @var visual3D Visual3DEntity */
                    this.visual3D.buildObject({
                        id: `~O~${i}`,
                        name: `Object n°${i}`,
                        status: null,

                        clickable: true,

                        container: 'sphere',
                        geometry: 'model',
                        model: '/commons/models/hammer/hammer.fbx',
                        material: {
                            map: '/commons/models/hammer/textures/hammer_classic.jpg',
                            roughness: 0.8,
                            metalness: 0,
                            transparency: true
                        },

                        position: {
                            x: (Math.random() - 0.5) * 100,
                            y: (Math.random() - 0.5) * 100,
                            z: (Math.random() - 0.5) * 100
                        },
                        rotation: {x: 0, y: 0, z: 0},
                        size: {x: 10, y: 10, z: 10},
                        subObjects: [
                            {
                                id: `~SO~0`,
                                name: `Object n°${i}`,
                                status: null,

                                parentId: `~O~${i}`,

                                geometry: 'text',
                                material: {
                                    side: 'double',
                                    color: "#FFF"
                                },
                                position: {x: 0, y: '-17', z: 0},
                                rotation: {x: 0, y: 0, z: 0},
                                size: 4
                            }
                            /*
                            {
                                id: 'CubeId',
                                name: 'Cube',
                                status: null,

                                clickable: true,

                                geometry: 'cube',
                                material: {
                                    color: '#FFF',
                                    roughness: 0.8,
                                    metalness: 0,
                                    transparency: true
                                },

                                position: {x: 0, y: 0, z: 0},
                                rotation: {x: 0, y: 0, z: 0},
                                size: {x: 10, y: 10, z: 10}
                            }
                             */

                        ]
                    });
                }

                /** @var visual3D Visual3DEntity */
                this.visual3D.buildObject({
                    id: 'CubeId',
                    name: 'Cube',
                    status: null,

                    clickable: true,

                    container: 'sphere',
                    geometry: 'cube',
                    material: {
                        color: '#FFF',
                        roughness: 0.8,
                        metalness: 0,
                        transparency: true
                    },

                    position: {x: 0, y: 0, z: 0},
                    rotation: {x: 0, y: 0, z: 0},
                    size: {x: 10, y: 10, z: 10}
                });
            },

            /**
             * Generate Lines between object.
             */
            generateLines() {
                /** @var visual3D Visual3DEntity */
                this.visual3D.buildLine({
                    id: 'Line1',
                    to: {id: '~O~10'},
                    from: {id: '~O~12'}
                });

                /** @var visual3D Visual3DEntity */
                this.visual3D.buildLine({
                    id: 'Line2',
                    to: {id: '~O~5'},
                    from: {id: '~O~20'}
                });

                /** @var visual3D Visual3DEntity */
                this.visual3D.buildLine({
                    id: 'Line3',
                    to: {id: '~O~8'},
                    from: {id: '~O~14'}
                });
            },


            clickObject(selected, object) {
                console.log(object);
            },

            removeObjectEvent() {
                /** @var visual3D Visual3DEntity */
                this.visual3D.removeObjectById('~O~24');
            },

            removeLineEvent() {
                /** @var visual3D Visual3DEntity */
                this.visual3D.removeLineById('Line1');
            }
        }
    }
</script>

<template>
    <section class="container">
        <article ref="PU" class="pu"></article>
        <article tabindex="0" style="padding: 50px">
            <button @click="removeObjectEvent">Remove Object</button>
            <button @click="removeLineEvent">Remove Line</button>
        </article>
    </section>
</template>